import string
from wxPython.wx import *

class NumValidator(wxPyValidator):
    def __init__(self, flag=None, pyVar=None):
        wxPyValidator.__init__(self)
        self.flag = flag
        EVT_CHAR(self, self.onChar) #eventManager.Register(self.onChar, EVT_CHAR, self)

	def __repr__(self):
		return '<%s, address: %s>' % (self.__class__.__name__, id(self))
		
    def Clone(self):
        return NumValidator(self.flag)

    def Validate(self, win):
        allowed = list(string.digits+'.')
        tc = self.GetWindow()
        val = tc.GetValue()
        for x in val:
            if x not in allowed:
                return 0

        return 1

    def onChar(self, event):
        key = event.KeyCode()
        if key < WXK_SPACE or key == WXK_DELETE or key > 255:
            event.Skip()
            return
        if chr(key) in list(string.digits+'.'+'-'):
            event.Skip()
            return
        if not wxValidator_IsSilent():
            wxBell()

        # Returning without calling even.Skip eats the event before it
        # gets to the text control
        return
